#include <iostream>
#include <string>
#include "bank.h"

using namespace std;

//CBank class
//constructor
CBank::CBank()
{
	DepositedGold=0.0;
}
//CBank functions
//Displays the bank menu
void CBank::DisplayMenu()
{
	//display bank menu
	cout<<"-------Bank Menu-------\n";
	cout<<" PLEASE CHOOSE FROM THE FOLLOWING OPTIONS \n";
	cout<<"A. View Balance\n";
	cout<<"B. Withdraw Gold\n";
	cout<<"C. Deposit Gold\n";
	cout<<"D. Exit Bank\n";
	cout<<"-----------------------\n";

}
//processes the menu choice made
int CBank::ProcessMenuChoice(std::string choice)
{
	//if the choice is an invalid length, return false
	if(choice.length()!=1)
	{
		cout<<"Invalid Choice!\n";
		return 0;
	}

	//if enter world is selected
	if(choice=="a" || choice=="A")
	{
		cout<<"View Balance Selected\n";
		return BANK_MENU_VIEW_BALANCE;
	}
	//if player is quitting (wanus)
	else if(choice=="b" || choice=="B")
	{
		cout<<"Withdraw Gold Selected\n";
		return BANK_MENU_WITHDRAW;
	}
	//if player is quitting (wanus)
	else if(choice=="c" || choice=="C")
	{
		cout<<"Deposit Gold Selected\n";
		return BANK_MENU_DEPOSIT;
	}
	//if player is quitting (wanus)
	else if(choice=="d" || choice=="D")
	{
		cout<<"Exit Bank Selected\n";
		return BANK_MENU_QUIT;
	}
	//something else selected, invalid choice
	else
	{
		cout<<"Invalid Choice!\n";
		return 0;
	}

	//if we made it this far, something is wrong
	cout<<"Something is Wrong\n";
	return 0;
}
//views the current gold in the bank
void CBank::ViewAccount()
{
	cout<<"You have "<<DepositedGold<<" gold in your account.\n";
}
//returns a double that is the amount withdrawn
double CBank::Withdraw()
{
	//amount requested
	string AmountInput;
	double AmountRequested;

	do
	{
		cout<<"You have "<<DepositedGold<<" gold in your account.\n";
		cout<<"How much would you like to withdraw?  ";
		cin>>AmountInput;
		cout<<endl;

		//we input a string and convert to a float to prevent a character being typed from creating
		//some sort of overrun
		AmountRequested=atof(AmountInput.c_str() );
		//if they ask for more than they have or a negative amount, tell them they are tards
		if(AmountRequested>DepositedGold || AmountRequested<0)
		{
			cout<<"Invalid amount, try again.\n";
		}

	//keep looping until they give good input
	}while(AmountRequested>DepositedGold || AmountRequested<0);

	//subtract amount from bank account
	DepositedGold-=AmountRequested;
	cout<<AmountRequested<<" gold withdrawn from the bank.\n";
	cout<<"You have "<<DepositedGold<<" gold remaining in your account.\n";

	//return the amount they wanted withdrawn
	return AmountRequested;
}
//returns a double that is the amount deposited
double CBank::Deposit(double PlayerAmount)
{
	//amount requested
	string AmountInput;
	double AmountRequested;

	do
	{
		cout<<"You have "<<DepositedGold<<" gold in your account.\n";
		cout<<"You have "<<PlayerAmount<<" on your person.\n";
		cout<<"How much would you like to deposit?  ";
		cin>>AmountInput;
		cout<<endl;

		//we input a string and convert to a float to prevent a character being typed from creating
		//some sort of overrun
		AmountRequested=atof(AmountInput.c_str() );
		//if they ask for more than they hold or a negative amount, tell them they are tards
		if(AmountRequested>PlayerAmount || AmountRequested<0)
		{
			cout<<"Invalid amount, try again.\n";
		}

	//keep looping until they give good input
	}while(AmountRequested>PlayerAmount || AmountRequested<0);

	//add amount from bank account
	DepositedGold+=AmountRequested;
	cout<<AmountRequested<<" gold deposited in the bank.\n";
	cout<<"You have "<<DepositedGold<<" gold remaining in your account.\n";

	//return the amount they wanted deposited
	return AmountRequested;
}
//returns a double with amount in account
double CBank::GetBalance()
{
	return DepositedGold;
}