#include <iostream>
#include <vector>
#include <string>
#include "characters.h"
#include "equipment.h"


using namespace std;

//CCharacter Class
//constructor
CCharacter::CCharacter()
{
	//set gold to 0
	Gold=0.0;
}
//CCharacter functions
//display stats of character
void CCharacter::DisplayStats(double BankedGold)
{
	cout<<"------------------------STATS------------------------------\n";
	cout<<"-----------------------WEAPON------------------------------\n";
	cout<<"You are wielding "<<Weapon.Name<<endl;
	cout<<"Damage: "<<Weapon.NumOfDice<<"d"<<Weapon.SidesOfDice<<endl;
	cout<<"Critical Hits on rolls of "<<Weapon.LowCriticalNumber<<" or higher.\n";
	cout<<"Critical Hit Damage Multiplier: "<<Weapon.CriticalMultiplier<<endl;
	cout<<"------------------------ARMOR------------------------------\n";
	cout<<"You are equipped with "<<Armor.Name<<endl;
	cout<<"AC: "<<Armor.ArmorClassValue<<endl;
	cout<<"Max Dexterity Bonus: "<<Armor.MaxDexterityModifier<<endl;
	cout<<"------------------------GOLD-------------------------------\n";
	cout<<"You have "<<Gold<<" gold on your person.\n";
	cout<<"You have "<<BankedGold<<" gold in your bank account.\n";
	cout<<"-----------------------------------------------------------\n";
}
//sets the weapon of the character to one from the worldlist
void CCharacter::SetWeapon(CWorldEquipment WorldEquipment, int WeaponID)
{
	for(int index=0;index<NUM_OF_WEAPONS;index++)
	{
		if(WorldEquipment.Weapons[index].ID==WeaponID)
		{
			Weapon.ID=WorldEquipment.Weapons[index].ID;
			Weapon.Name=WorldEquipment.Weapons[index].Name;
			Weapon.NumOfDice=WorldEquipment.Weapons[index].NumOfDice;
			Weapon.SidesOfDice=WorldEquipment.Weapons[index].SidesOfDice;
			Weapon.LowCriticalNumber=WorldEquipment.Weapons[index].LowCriticalNumber;
			Weapon.CriticalMultiplier=WorldEquipment.Weapons[index].CriticalMultiplier;
			Weapon.PurchasePrice=WorldEquipment.Weapons[index].PurchasePrice;
			
			cout<<"Weapon Set to "<<Weapon.Name<<endl;

			return;//stop looking, we found it
		}
	}
	cout<<"Weapon Not Found\n";
}
//sets the armor of the character to one from the worldlist
void CCharacter::SetArmor(CWorldEquipment WorldEquipment, int ArmorID)
{
	for(int index=0;index<NUM_OF_ARMOR;index++)
	{
		if(WorldEquipment.Armor[index].ID==ArmorID)
		{
			Armor.ID=WorldEquipment.Armor[index].ID;
			Armor.Name=WorldEquipment.Armor[index].Name;
			Armor.ArmorClassValue=WorldEquipment.Armor[index].ArmorClassValue;
			Armor.MaxDexterityModifier=WorldEquipment.Armor[index].MaxDexterityModifier;
			Armor.PurchasePrice=WorldEquipment.Armor[index].PurchasePrice;
			
			cout<<"Armor Set to "<<Armor.Name<<endl;

			return;//stop looking, we found it
		}
	}
	//if we made it this far, they did something silly
	cout<<"Armor Not Found\n";
}


//CPlayerCharacter class
//constructor
CPlayerCharacter::CPlayerCharacter()
{
	//give the player some starting gold
	Gold=10.0;
}