#include <iostream>
#include <vector>
#include <string>
#include <fstream>
#include "equipment.h"

using namespace std;

//do a class for weapons, armor, items
//then add an inventory class that has a vector of weapons, armor, items
//then add the inventory class to the base character class
//then make containers for the worldlist of items,armor,weapons.  maybe?

//CItem class
//constructor
CItem::CItem()
{

}

//CWeapon Class
//constructor
CWeapon::CWeapon()
{

}

//CArmor Class
//constructor
CArmor::CArmor()
{
	
}

//CWorldEquipment Class
//constructor
CWorldEquipment::CWorldEquipment()
{
	//resize weapon vector
	Weapons.resize(NUM_OF_WEAPONS);
	//resize armor vector
	Armor.resize(NUM_OF_ARMOR);
}
//functions
//loads the weapons into the world list from a text file
void CWorldEquipment::LoadWeapons(char *filename)
{
	cout<<"Loading Weapon List\n";

	//load weapon list into weapon class array
	char TextInformation[300];//holds input information from read files
	char *TextParsed;//holds string token information
	//open file
	fstream file_open(filename,ios::in);

	//for each item in file, get a new line
	int index=1;
	while( !file_open.eof() )
	{
		//get a new line from the file
		file_open.getline(TextInformation,300);
		//set first item to the first semicolon
		TextParsed=strtok(TextInformation,";");
		int ID=atoi(TextParsed);//first item is ID, which will be used to index the vector
		Weapons[index].ID=ID;//gives the weapon it's unique ID
		TextParsed=strtok(NULL,";");
		Weapons[index].Name=TextParsed;//next item is name
		TextParsed=strtok(NULL,";");
		Weapons[index].NumOfDice=atoi(TextParsed);//number of dice used
		TextParsed=strtok(NULL,";");
		Weapons[index].SidesOfDice=atoi(TextParsed);//sided dice to use
		TextParsed=strtok(NULL,";");
		Weapons[index].LowCriticalNumber=atoi(TextParsed);//critical hit range
		TextParsed=strtok(NULL,";");
		Weapons[index].CriticalMultiplier=atoi(TextParsed);//critical hit multiplier
		TextParsed=strtok(NULL,";");
		Weapons[index].PurchasePrice=atof(TextParsed);//price to buy
		
		index++;//increment
	}
	file_open.close();//close file

	//index -1 because we are 1 indexed in this vector
	cout<<index-1<<" weapons loaded.\n";

}
//displays the world weapons, probably just for debugging purposes
void CWorldEquipment::DisplayWeapons()
{
	for(int index=1;index<NUM_OF_WEAPONS;index++)
	{
		/*if name is invalid, stop the list, this is pretty much a hack because the vector
		may not originally be sized to the exact amount of weapons loaded.
		This stops a bunch of gobbledy gook from being displayed*/
		if(Weapons[index].Name.length()<2)
		{
			break;
		}

		//weapon index and name
		cout<<index<<")"<<Weapons[index].Name;
		//line up stats
		if( (index<10 && Weapons[index].Name.length()<6 ) || (index>=10 && Weapons[index].Name.length()<5) )
		{
			cout<<"\t\t\t";
		}
		else if( (index<10 && Weapons[index].Name.length()<12 ) ||
			(index>=10 && Weapons[index].Name.length()<11) )
		{
			cout<<"\t\t";
		}
		else
		{
			cout<<"\t";
		}
		//damage
		cout<<Weapons[index].NumOfDice<<"d"<<Weapons[index].SidesOfDice<<"\t";
		//critical rolls
		if(Weapons[index].LowCriticalNumber<20)
		{
			cout<<"("<<Weapons[index].LowCriticalNumber<<"-20";
		}
		else
		{
			cout<<"("<<Weapons[index].LowCriticalNumber;
		}
		//critical multiplier
		cout<<"/x"<<Weapons[index].CriticalMultiplier<<")\t";

		//line up stats again
		if(Weapons[index].LowCriticalNumber==20)
		{cout<<"\t";}

		//purchase price
		cout<<Weapons[index].PurchasePrice<<"g";
		//show weapon ID
		cout<<"\tID#"<<Weapons[index].ID;

		cout<<endl;
	}
	
}
//displays a world weapon given the ID and the purchaseslot (for lining up)
void CWorldEquipment::DisplayWeapon(int PurchaseSlot, int WeaponID)
{
	for(int index=1;index<NUM_OF_WEAPONS;index++)
	{
		if(Weapons[index].ID!=WeaponID)
		{}
		else if(Weapons[index].ID==WeaponID)
		{
			//weapon index and name
			cout<<PurchaseSlot<<")"<<Weapons[index].Name;
			//line up stats
			if( (index<10 && Weapons[index].Name.length()<6 ) || (index>=10 && Weapons[index].Name.length()<5) )
			{
				cout<<"\t\t\t";
			}
			else if( (index<10 && Weapons[index].Name.length()<12 ) ||
				(index>=10 && Weapons[index].Name.length()<11) )
			{
				cout<<"\t\t";
			}
			else
			{
				cout<<"\t";
			}
			//damage
			cout<<Weapons[index].NumOfDice<<"d"<<Weapons[index].SidesOfDice<<"\t";
			//critical rolls
			if(Weapons[index].LowCriticalNumber<20)
			{
				cout<<"("<<Weapons[index].LowCriticalNumber<<"-20";
			}
			else
			{
				cout<<"("<<Weapons[index].LowCriticalNumber;
			}
			//critical multiplier
			cout<<"/x"<<Weapons[index].CriticalMultiplier<<")\t";

			//line up stats again
			if(Weapons[index].LowCriticalNumber==20)
			{cout<<"\t";}

			//purchase price
			cout<<Weapons[index].PurchasePrice<<"g";
			//show weapon ID
			cout<<"\tID#"<<Weapons[index].ID;

			cout<<endl;

			return;//stop looking, we have the weapon we need
		}
	}
	
}
//loads the armor into the world list from a text file
void CWorldEquipment::LoadArmor(char *filename)
{
	cout<<"Loading Armor List\n";

	//load armor list into armor class array
	char TextInformation[300];//holds input information from read files
	char *TextParsed;//holds string token information
	//open file
	fstream file_open(filename,ios::in);

	//for each item in file, get a new line
	int index=1;
	while( !file_open.eof() )
	{
		//get a new line from the file
		file_open.getline(TextInformation,300);
		//set first item to the first semicolon
		TextParsed=strtok(TextInformation,";");
		int ID=atoi(TextParsed);//first item is ID, which will be used to index the vector
		Armor[index].ID=ID;//gives the armor it's unique ID
		TextParsed=strtok(NULL,";");
		Armor[index].Name=TextParsed;//next item is name
		TextParsed=strtok(NULL,";");
		Armor[index].ArmorClassValue=atoi(TextParsed);//armorclass value
		TextParsed=strtok(NULL,";");
		Armor[index].MaxDexterityModifier=atoi(TextParsed);//max dexterity bonus
		TextParsed=strtok(NULL,";");
		Armor[index].PurchasePrice=atof(TextParsed);//price to buy
		
		index++;//increment
	}
	file_open.close();//close file

	//index -1 because we are 1 indexed in this vector
	cout<<index-1<<" armor loaded.\n";

}
//displays all the world armor, probably just for debugging purposes
void CWorldEquipment::DisplayAllArmor()
{
	for(int index=1;index<NUM_OF_ARMOR;index++)
	{
		/*if name is invalid, stop the list, this is pretty much a hack because the vector
		may not originally be sized to the exact amount of armor loaded.
		This stops a bunch of gobbledy gook from being displayed*/
		if(Armor[index].Name.length()<2)
		{
			break;
		}

		//armor index and name
		cout<<index<<")"<<Armor[index].Name;
		//line up stats
		if( (index<10 && Armor[index].Name.length()<6 ) || (index>=10 && Armor[index].Name.length()<5) )
		{
			cout<<"\t\t\t";
		}
		else if( (index<10 && Armor[index].Name.length()<14 ) ||
			(index>=10 && Armor[index].Name.length()<13) )
		{
			cout<<"\t\t";
		}
		else
		{
			cout<<"\t";
		}
		//AC Value
		cout<<"AC: +"<<Armor[index].ArmorClassValue<<"\t";
		//max dexterity
		cout<<"Max Dex: +"<<Armor[index].MaxDexterityModifier<<"\t";
		//purchase price
		cout<<Armor[index].PurchasePrice<<"g";
		//show armor ID
		cout<<"\tID#"<<Armor[index].ID;

		cout<<endl;
	}
	
}
//displays a world armor given the ID and the purchaseslot (for lining up)
void CWorldEquipment::DisplayArmor(int PurchaseSlot, int ArmorID)
{
	for(int index=1;index<NUM_OF_ARMOR;index++)
	{
		if(Armor[index].ID!=ArmorID)
		{}
		else if(Armor[index].ID==ArmorID)
		{
			//armor index and name
			cout<<PurchaseSlot<<")"<<Armor[index].Name;
			//line up stats
			if( (index<10 && Armor[index].Name.length()<6 ) || (index>=10 && Armor[index].Name.length()<5) )
			{
				cout<<"\t\t\t";
			}
			else if( (index<10 && Armor[index].Name.length()<14 ) ||
				(index>=10 && Armor[index].Name.length()<13) )
			{
				cout<<"\t\t";
			}
			else
			{
				cout<<"\t";
			}

			//AC Value
			cout<<"AC: +"<<Armor[index].ArmorClassValue<<"\t";
			//max dexterity
			cout<<"Max Dex: +"<<Armor[index].MaxDexterityModifier<<"\t";
			//purchase price
			cout<<Armor[index].PurchasePrice<<"g";
			//show armor ID
			cout<<"\tID#"<<Armor[index].ID;

			cout<<endl;

			return;//stop looking, we have the armor we need
		}
	}
	
}