//Contains the classes for equipment (armor, weapons, items)
#ifndef EQUIPMENT_H
#define EQUIPMENT_H


//constants
const int NUM_OF_WEAPONS=50;
const int NUM_OF_ARMOR=50;

//class for general items
class CItem
{
public:
	CItem();
private:
};

//class for weapons
class CWeapon
{
public:
	CWeapon();
	
	std::string Name;//name of weapon
	int CriticalMultiplier;//how many times the damage is multiplied by on a critical hit
	/*the lowest number used when calculating critical hits
	ie a natural 20 would be 20, 18-20 would be 18*/
	int LowCriticalNumber;
	/*number of dice is the number of dice used in the damage through,
	sidesofdice is the number of sides on those dice used.
	So for example a 2d8 weapon would have numofdice of 2 and sidesofdice of 8*/
	int NumOfDice;
	int SidesOfDice;

	double PurchasePrice;//how much gold the weapon costs

	/*the weapon may not always be listed in the numbered order. giving each weapon a unique ID
	allows us to identify an item by it's ID # and not necessarily in the position it was indexed to.
	Hopefully it gives us database functionality without having to use a database.*/
	int ID;//stores the weapon's ID.
private:
};

//class for Armor
class CArmor
{
public:
	CArmor();

	std::string Name;//name of armor
	int ArmorClassValue;//armor class value of armor
	int MaxDexterityModifier;//maximum dexterity bonus allowed while wearing armor

	double PurchasePrice;//how much gold the armor costs

	/*the armor may not always be listed in the numbered order. giving each item a unique ID
	allows us to identify an item by it's ID # and not necessarily in the position it was indexed to.
	Hopefully it gives us database functionality without having to use a database.*/
	int ID;//stores the armor's ID.
};



//class that holds the list of all weapons/items/armor in the world
class CWorldEquipment
{
public:
	CWorldEquipment();

	std::vector <CWeapon> Weapons;
	void LoadWeapons(char *filename);
	void DisplayWeapons();//displays all weapons, for debugging purposes
	/*displays a single weapon for shop convenience.  purchaseslot is the slot it will be shown under,
	this helps us line it up using tabs, aka slot 1 may line up different than slot 10)*/
	void DisplayWeapon(int PurchaseSlot,int WeaponID);

	std::vector <CArmor> Armor;
	void LoadArmor(char *filename);
	void DisplayAllArmor();//displays all weapons, for debugging purposes
	/*displays a single weapon for shop convenience.  purchaseslot is the slot it will be shown under,
	this helps us line it up using tabs, aka slot 1 may line up different than slot 10)*/
	void DisplayArmor(int PurchaseSlot,int ArmorID);

private:
};


#endif