#include <iostream>
#include <fstream>
#include <string>
#include <vector>

#include "World.h"

using namespace std;


//CRoom constructor
CRoom::CRoom()
{
	//show us that we've created a room, eat your heart out Ty Pennington
	cout<<"Room created"<<endl;

	//resize the exits vector to 4, for north,south,east,west
	Exits.resize(NUM_OF_DIRECTIONS);
}

//CWorld constructor
CWorld::CWorld()
{
	//show us that we've created the world, we're totally not God though
	cout<<"World created"<<endl;

	//resize the vector of rooms to the number of rooms that we have
	Rooms.resize(NUM_OF_ROOMS);
}
//CWorld functions
//displays the room, extra gobbledidy gook for now
void CWorld::DisplayRoom(int RoomID)
{
	/*debug information, comment out when not needed*/
	/*
	cout<<"Room given is: "<<RoomID<<". And the stored ID is:"<<Rooms[RoomID].ID<<endl;

	cout<<"North Exit is: "<<Rooms[RoomID].Exits[NORTH]<<endl;
	cout<<"East Exit is: "<<Rooms[RoomID].Exits[EAST]<<endl;
	cout<<"South Exit is: "<<Rooms[RoomID].Exits[SOUTH]<<endl;
	cout<<"West Exit is: "<<Rooms[RoomID].Exits[WEST]<<endl;

	cout<<"Room flags: "<<Rooms[RoomID].Flags<<endl;

	cout<<"Description: "<<Rooms[RoomID].Description<<endl;
	*/

	//show room description
	cout<<Rooms[RoomID].Description<<endl;
	
	//show exits
	cout<<"Obvious Exits: ";
	if(Rooms[RoomID].Exits[NORTH]!=0)
		cout<<"(N)orth ";
	if(Rooms[RoomID].Exits[SOUTH]!=0)
		cout<<"(S)outh ";
	if(Rooms[RoomID].Exits[WEST]!=0)
		cout<<"(W)est ";
	if(Rooms[RoomID].Exits[EAST]!=0)
		cout<<"(E)ast ";
	cout<<endl;
}
//loads the rooms into the world from a .txt file
void CWorld::LoadRooms(char *filename)
{
	char TextInformation[1000];//holds input information from read files
	char *TextParsed;//holds string token information

	//open file
	fstream file_open(filename,ios::in);
	//for each item in class array, get a new line
	while(!file_open.eof())
	{
		//get a new line from the file
		file_open.getline(TextInformation,1000);

		//set first item to the first semicolon
		TextParsed=strtok(TextInformation,";");

		//first item is room id
		int RoomID=atoi(TextParsed);
		Rooms[RoomID].ID=RoomID;

		//continue parsing until end of line
		//The next section are the exits separated by commas
		//after getting the exit we store them in the correct vector spot for the room
		TextParsed=strtok(NULL,",");
		Rooms[RoomID].Exits[NORTH]=atoi(TextParsed);
		TextParsed=strtok(NULL,",");
		Rooms[RoomID].Exits[EAST]=atoi(TextParsed);
		TextParsed=strtok(NULL,",");
		Rooms[RoomID].Exits[SOUTH]=atoi(TextParsed);
		TextParsed=strtok(NULL,";");
		Rooms[RoomID].Exits[WEST]=atoi(TextParsed);
		
		TextParsed=strtok(NULL,";");//blacksmith ID
		Rooms[RoomID].BlacksmithID=atoi(TextParsed);
		TextParsed=strtok(NULL,";");//armory ID
		Rooms[RoomID].ArmoryID=atoi(TextParsed);
		TextParsed=strtok(NULL,";");//general items ID
		Rooms[RoomID].GeneralItemsID=atoi(TextParsed);
		TextParsed=strtok(NULL,";");//0 if no bank, 1 if there is
		Rooms[RoomID].isBank=atoi(TextParsed);

		//the next section will be the room description
		//we keep adding the next line to the description until it terminates with a ';'
		string RoomDescription;
		//while there is no semicolon in the description
		while(RoomDescription.find(";")==string::npos)
		{
			file_open.getline(TextInformation,1000);
			//set room description up to semicolon
			RoomDescription+=TextInformation;
		}
		//get rid of semi-colon in description
		RoomDescription.replace(RoomDescription.find(";"),1,"");
		//add the descriptino to the vector
		Rooms[RoomID].Description=RoomDescription;
	}
	file_open.close();//close file

	cout<<"File closed\n";

}
//displays the menu for the current room
void CWorld::DisplayRoomMenu(int RoomID)
{
	cout<<"----------------------MENU-------------------------\n";
	cout<<"V) View Stats\n";

	if(Rooms[RoomID].isBank)
	{
		cout<<"B)Perform Banking Functions\n";
	}

	if(Rooms[RoomID].ArmoryID)
	{
		cout<<"A)Purchase Armor\n";
	}

	if(Rooms[RoomID].BlacksmithID)
	{
		cout<<"L)Purchase Weapons\n";
	}

	if(Rooms[RoomID].GeneralItemsID)
	{
		cout<<"G)Purchase General Items\n";
	}

	cout<<"Q)Quit\n";
	cout<<"--------------------------------------------------\n";
}
//processes the menu choice for the room
int CWorld::ProcessRoomMenuChoice(string choice,int RoomID)
{
	//if the choice is an invalid length, return false
	if(choice.length()!=1)
	{
		cout<<"Invalid Choice!\n";
		return 0;
	}

	//if enter world is selected
	if(choice=="v" || choice=="V")
	{
		cout<<"View Stats Selected\n";
		return ROOM_MENU_VIEW_STATS;
	}
	//if player is quitting (wanus)
	else if(choice=="q" || choice=="Q")
	{
		cout<<"Quitting?? Shlub...\n";
		return ROOM_MENU_QUIT;
	}
	
	//if they select the bank
	if(choice=="b" || choice=="B")
	{
		//if there is no bank, bail
		if(!Rooms[RoomID].isBank)
		{
			cout<<"Sorry you can't do that here\n";
			return 0;
		}
		else
		{
			cout<<"Bank Selected\n";
			return ROOM_MENU_BANK;
		}
	}

	//if they select armory
	if(choice=="a" || choice=="A")
	{
		//if there is no armory, smack them
		if(!Rooms[RoomID].ArmoryID)
		{
			cout<<"Sorry you can't do that here\n";
			return 0;
		}
		else
		{
			cout<<"Armory Selected\n";
			return ROOM_MENU_ARMORY;
		}
	}

	//if they select the blacksmith
	if(choice=="l" || choice=="L")
	{
		//if there is no blacksmith, pierce their heart with the knowledge stick
		if(!Rooms[RoomID].BlacksmithID)
		{
			cout<<"Sorry you can't do that here\n";
			return 0;
		}
		else
		{
			cout<<"BlackSmith Selected\n";
			return ROOM_MENU_BLACKSMITH;
		}
	}

	//if they select the general store
	if(choice=="g" || choice=="G")
	{
		//if there is no general store, comfort their sorrows
		if(!Rooms[RoomID].GeneralItemsID)
		{
			cout<<"Sorry you can't do that here\n";
			return 0;
		}
		else
		{
			cout<<"General Items Selected\n";
			return ROOM_MENU_GENERAL_STORE;
		}
	}

	//by now you should have the idea....
	if(choice=="n" || choice=="N")
	{
		if(Rooms[RoomID].Exits[NORTH]==0)
		{
			cout<<"Sorry you can't do that here\n";
			return 0;
		}
		else
		{
			cout<<"Moving North...\n";
			return ROOM_MENU_NORTH;
		}
	}
	if(choice=="e" || choice=="E")
	{
		if(Rooms[RoomID].Exits[EAST]==0)
		{
			cout<<"Sorry you can't do that here\n";
			return 0;
		}
		else
		{
			cout<<"Moving east...\n";
			return ROOM_MENU_EAST;
		}
	}
	if(choice=="s" || choice=="S")
	{
		if(Rooms[RoomID].Exits[SOUTH]==0)
		{
			cout<<"Sorry you can't do that here\n";
			return 0;
		}
		else
		{
			cout<<"Moving South...\n";
			return ROOM_MENU_SOUTH;
		}
	}
	if(choice=="w" || choice=="W")
	{
		if(Rooms[RoomID].Exits[WEST]==0)
		{
			cout<<"Sorry you can't do that here\n";
			return 0;
		}
		else
		{
			cout<<"Moving West...\n";
			return ROOM_MENU_WEST;
		}
	}


	//something else selected, invalid choice
	else
	{
		cout<<"Invalid Choice!\n";
		return 0;
	}

	//if we made it this far, something is wrong
	cout<<"Something is Wrong\n";
	return 0;
}