//World and Room Classes

#ifndef WORLD_H
#define WORLD_H

//enumerate directions for the CRoom Exits vector
enum ExitDirections {NORTH=0,EAST=1,SOUTH=2,WEST=3};

//constants
const int NUM_OF_DIRECTIONS=4;
const int NUM_OF_ROOMS=1000;

const int ROOM_MENU_VIEW_STATS=1;
const int ROOM_MENU_BANK=2;
const int ROOM_MENU_ARMORY=3;
const int ROOM_MENU_QUIT=4;
const int ROOM_MENU_BLACKSMITH=5;
const int ROOM_MENU_GENERAL_STORE=6;
const int ROOM_MENU_NORTH=10;
const int ROOM_MENU_EAST=11;
const int ROOM_MENU_SOUTH=12;
const int ROOM_MENU_WEST=13;

//class for individual rooms
class CRoom
{
public:
	CRoom();//constructor
	std::string Description;//Description of Room
	int ID;//holds ID of room
	std::vector<int> Exits;//holds id's of exits, 0 for no exit in that direction
	int BlacksmithID;//ID of the blacksmith in location, 0 if no blacksmith
	int ArmoryID;//ID of the armory in location, 0 if no armory
	int GeneralItemsID;//ID of the general item store in location, 0 if no general store
	bool isBank;//is there a bank in the room
};

//class that contains a vector of all the rooms and some displaying functions
class CWorld
{
public:
	CWorld();//constructor
	/*the room vector stores all the rooms in the world, the index is equal to the rooms
	ID, so for example, a room with the ID of 250 is stored in Rooms[250]*/
	std::vector<CRoom> Rooms;
	void DisplayRoom(int RoomID);//displays a room based on its id
	void LoadRooms(char *filename);//loads the rooms from a text file

	/*I can't figure out a way to get these outside of this class, so i will put them here
	and also this header file will include the menu constants*/
	void DisplayRoomMenu(int RoomID);//displays the menu for the current room
	int ProcessRoomMenuChoice(std::string choice,int RoomID);//process the room menu choice
};



#endif