//Console Combat 2 by Adam Sepanski
//Project Started 11/21/2006

#include <iostream>
#include <string>
#include <vector>
#include <conio.h>
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include "menu.h"
#include "world.h"
#include "equipment.h"
#include "characters.h"
#include "bank.h"
#include "consolesettings.h"
#include "shops.h"

using namespace std;


int main()
{
	//for colored text
	HANDLE hConsole;//handle to the console
	hConsole=GetStdHandle( STD_OUTPUT_HANDLE );//get the handle
	string AppTitle="Console Combat 2!  At least twice as fun as the original";
	SetConsoleTitle(AppTitle.c_str() );//set the title of the console
	/* testing size stuff
	COORD size;
	size.X=500;
	size.Y=300;
	SMALL_RECT rect;
	rect.Top=10;
	rect.Bottom=300;
	rect.Left=10;
	rect.Right=500;
	SetConsoleScreenBufferSize(hConsole,size);
	SetConsoleWindowInfo(hConsole,true,&rect);
	*/

	//create main menu
	CMainMenu MainMenu;
	string MainMenuChoice;//choice used to select menu option
	int MainMenuOption=0;//the menu option selected

	//create the world, MUHAHAHA
	CWorld World;
	World.LoadRooms("rooms.txt");
	string RoomMenuChoice;//choice used to select the room menu
	int RoomMenuOption=0;//room menu option selected

	//create the bank, Alan Greenspan style
	CBank Bank;
	string BankMenuChoice;//choice used to select the bank menu
	int BankMenuOption=0;//bank menu option selected

	//create the world list of equipment
	CWorldEquipment WorldEquipment;
	WorldEquipment.LoadWeapons("weaponlist.txt");//load the weapons from the external file
	WorldEquipment.LoadArmor("armorlist.txt");//load the armor from a file
	//WorldEquipment.DisplayAllArmor();

	//create the list of shops
	CShops Shops;
	Shops.LoadBlacksmiths("blacksmiths.txt");
	Shops.LoadArmorers("armorers.txt");

	//create the main character, nothing funny to say here
	CPlayerCharacter Player;
	Player.SetWeapon(WorldEquipment,1);
	Player.SetArmor(WorldEquipment,2);

	//display the main menu
	//set the menu color to white
	SetTextColor(hConsole,TEXT_WHITE,false);
	MainMenu.DisplayMenu();
	
	//get user input
	//set input to bright white
	SetTextColor(hConsole,TEXT_WHITE);
	cout<<"Your Choice: ";
	cin>>MainMenuChoice;

	//find out what they selected
	SetTextColor(hConsole,TEXT_WHITE,false);
	MainMenuOption=MainMenu.ProcessMenuChoice(MainMenuChoice);

	//if the selection is invalid, keep asking until it is valid
	while( !MainMenuOption )
	{
		SetTextColor(hConsole,TEXT_WHITE);
		cout<<"Your Choice: ";
		cin>>MainMenuChoice;
		SetTextColor(hConsole,TEXT_WHITE,false);
		MainMenuOption=MainMenu.ProcessMenuChoice(MainMenuChoice);
	}

	//if they entered into the world
	if(MainMenuOption==MAIN_MENU_ENTER_WORLD)
	{
		Player.RoomID=1;

		bool GameDone=false;
		while(!GameDone)
		{
			//set the description color to green
			SetTextColor(hConsole,TEXT_GREEN);
			//load room
			World.DisplayRoom(Player.RoomID);

			//set the menu color to white
			SetTextColor(hConsole,TEXT_WHITE,false);
			//display room menu
			World.DisplayRoomMenu(Player.RoomID);

			//get user input
			//set input to bright white
			SetTextColor(hConsole,TEXT_WHITE);
			cout<<"Your Choice: ";
			cin>>RoomMenuChoice;
			//find out what they selected
			SetTextColor(hConsole,TEXT_WHITE,false);
			RoomMenuOption=World.ProcessRoomMenuChoice(RoomMenuChoice,Player.RoomID);

			//if the selection is invalid, keep asking until it is valid
			while( !RoomMenuOption )
			{
				SetTextColor(hConsole,TEXT_WHITE);
				cout<<"Your Choice: ";
				cin>>RoomMenuChoice;
				SetTextColor(hConsole,TEXT_WHITE,false);
				RoomMenuOption=World.ProcessRoomMenuChoice(RoomMenuChoice,Player.RoomID);
			}
			
			/*if they chose to move, set the new room ID*/
			if(RoomMenuOption==ROOM_MENU_NORTH)
			{
				Player.RoomID=World.Rooms[Player.RoomID].Exits[NORTH];
			}
			else if(RoomMenuOption==ROOM_MENU_SOUTH)
			{
				Player.RoomID=World.Rooms[Player.RoomID].Exits[SOUTH];
			}
			else if(RoomMenuOption==ROOM_MENU_WEST)
			{
				Player.RoomID=World.Rooms[Player.RoomID].Exits[WEST];
			}
			else if(RoomMenuOption==ROOM_MENU_EAST)
			{
				Player.RoomID=World.Rooms[Player.RoomID].Exits[EAST];
			}

			//if they want to view stats
			else if(RoomMenuOption==ROOM_MENU_VIEW_STATS)
			{
				//set the stat menu color to green
				SetTextColor(hConsole,TEXT_BLUE);
				Player.DisplayStats( Bank.GetBalance() );
				//set the color back to white cause we don't know what may happen after this
				//set the color to white
				SetTextColor(hConsole,TEXT_WHITE,false);
			}
			//if they quit, quit
			else if(RoomMenuOption==ROOM_MENU_QUIT)
			{
				cout<<"Later Noob\n";
				GameDone=true;
			}
			
			//if they choose the bank, enter the bank
			else if(RoomMenuOption==ROOM_MENU_BANK)
			{
				bool BankDone=false;
				while(!BankDone)
				{
					//set the bank menu color to white
					SetTextColor(hConsole,TEXT_WHITE,false);
					Bank.DisplayMenu();

					SetTextColor(hConsole,TEXT_WHITE);
					cout<<"Your choice: ";
					cin>>BankMenuChoice;
					SetTextColor(hConsole,TEXT_WHITE,false);
					BankMenuOption=Bank.ProcessMenuChoice(BankMenuChoice);

					//if the selection is invalid, keep asking until it is valid
					while( !BankMenuOption )
					{
						SetTextColor(hConsole,TEXT_WHITE);
						cout<<"Your Choice: ";
						cin>>BankMenuChoice;
						SetTextColor(hConsole,TEXT_WHITE,false);
						BankMenuOption=Bank.ProcessMenuChoice(BankMenuChoice);
					}

					if(BankMenuOption==BANK_MENU_VIEW_BALANCE)
					{
						//set the bank display to green
						SetTextColor(hConsole,TEXT_BLUE);
						Bank.ViewAccount();
					}
					else if(BankMenuOption==BANK_MENU_WITHDRAW)
					{
						SetTextColor(hConsole,TEXT_BLUE);
						//add to players gold by withdrawn amount
						Player.Gold+=Bank.Withdraw();
					}
					else if(BankMenuOption==BANK_MENU_DEPOSIT)
					{
						SetTextColor(hConsole,TEXT_BLUE);
						//subtract gold from the player by the amount deposited
						Player.Gold-=Bank.Deposit(Player.Gold);
					}
					else if(BankMenuOption==BANK_MENU_QUIT)
					{
						BankDone=true;
					}
				}

			}

			//if they choose to purchase armor
			else if(RoomMenuOption==ROOM_MENU_ARMORY)
			{
				//it's the armors shop with the id of the room that the player is in...
				Shops.Armorers[ World.Rooms[Player.RoomID].ArmoryID ].DisplayItemsForSale(WorldEquipment);

				string choice;
				SetTextColor(hConsole,TEXT_WHITE);
				cout<<"Your choice: ";
				cin>>choice;
				SetTextColor(hConsole,TEXT_WHITE,false);

				//while the selection is invalid or they aren't leaving the shop
				while( choice!="q" && choice!="Q" &&
					!Shops.Armorers[ World.Rooms[Player.RoomID].ArmoryID ].PurchaseArmor(WorldEquipment,Player,atoi( choice.c_str() ) ) )
				{
					SetTextColor(hConsole,TEXT_WHITE);
					cout<<"Your choice: ";
					cin>>choice;
					SetTextColor(hConsole,TEXT_WHITE,false);
				}
			}

			//if they choose to buy a weapon
			else if(RoomMenuOption==ROOM_MENU_BLACKSMITH)
			{
				//it's the blacksmith shop with the id of the room that the player is in...
				Shops.Blacksmiths[ World.Rooms[Player.RoomID].BlacksmithID ].DisplayItemsForSale(WorldEquipment);

				string choice;
				SetTextColor(hConsole,TEXT_WHITE);
				cout<<"Your choice: ";
				cin>>choice;
				SetTextColor(hConsole,TEXT_WHITE,false);

				//while the selection is invalid or they aren't leaving the shop
				while( choice!="q" && choice!="Q" &&
					!Shops.Blacksmiths[ World.Rooms[Player.RoomID].BlacksmithID ].PurchaseWeapon(WorldEquipment,Player,atoi( choice.c_str() ) ) )
				{
					SetTextColor(hConsole,TEXT_WHITE);
					cout<<"Your choice: ";
					cin>>choice;
					SetTextColor(hConsole,TEXT_WHITE,false);
				}

			}


		}
	}

	//if they quit, say buh-bye
	else if(MainMenuOption==MAIN_MENU_QUIT)
	{
		return 0;
	}

	return 0;
}